//+------------------------------------------------------------------+
//|                                                   SampleList.mq5 |
//|                        Copyright 2010, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2009, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
class CListItem
  {
private:
   int               m_ID;
   CListItem        *m_next;
   CListItem        *m_prev;
public:
                    ~CListItem();
   void              setID(int id){m_ID=id;}
   int               getID(){return(m_ID);}
   void              next(CListItem *item){m_next=item;}
   void              prev(CListItem *item){m_prev=item;}
   CListItem*        next(){return(m_next);}
   CListItem*        prev(){return(m_prev);}
  };
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
CListItem::~CListItem(void)
  {
   if(CheckPointer(m_next)==POINTER_DYNAMIC)
     {
      delete(m_next);
      Print(__FUNCTION__,"    ID=",m_ID);
     }
   else
      Print(__FUNCTION__,"   ",m_ID,"   next");

  }
//+------------------------------------------------------------------+
//|                                                   |
//+------------------------------------------------------------------+
class CList
  {
private:
   int               m_counter;
   CListItem        *m_first;
public:
                     CList(){m_counter=0;}
                    ~CList();
   void              addItem(CListItem *item);
   int               size(){return(m_counter);}
  };
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
CList::~CList(void)
  {
   int ID=m_first.getID();
   if(CheckPointer(m_first)==POINTER_DYNAMIC) delete(m_first);
   Print(__FUNCTION__,"      ID=",ID);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
CList::addItem(CListItem *item)
  {
//---     
   if(CheckPointer(item)==POINTER_INVALID) return;
//---     
   m_counter++;
//---      
   if(CheckPointer(m_first)!=POINTER_DYNAMIC)
     {
      m_first=item;
     }
   else
     {
      //---   item   
      m_first.prev(item);
      //---     
      CListItem *p=m_first;
      //---       item
      m_first=item;
      //---        
      m_first.next(p);
     }
  }
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
//---
   CList list;
   for(int i=0;i<7;i++)
     {
      CListItem *item=new CListItem;
      item.setID(i);
      list.addItem(item);
     }
     Print("  ",list.size()," ");
  }
//+------------------------------------------------------------------+
